/*
 *   Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.12.25 at 01:02:08 PM CET 
//

package net.ihe.gazelle.audit.message.desc;

import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import java.io.Serializable;

/**
 * <p>
 * Java class for ParticipantObjectIdentificationDesc complex type.
 * 
 * <p>
 * The following schema fragment specifies the expected content contained within
 * this class.
 * 
 * <pre>
 * &lt;complexType name=&quot;ParticipantObjectIdentificationDesc&quot;&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base=&quot;{http://www.w3.org/2001/XMLSchema}anyType&quot;&gt;
 *       &lt;sequence&gt;
 *         &lt;element name=&quot;ParticipantObjectTypeCode&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectTypeCodeRole&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectDataLifeCycle&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectIDTypeCode&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectSensitivity&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectID&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectName&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectQuery&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;ParticipantObjectDetail&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *       &lt;/sequence&gt;
 *       &lt;attribute name=&quot;cardinality&quot; type=&quot;{}Cardinality&quot; default=&quot;0..1&quot; /&gt;
 *       &lt;attribute name=&quot;name&quot; type=&quot;{http://www.w3.org/2001/XMLSchema}string&quot; /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ParticipantObjectIdentificationDesc", propOrder = {
		"participantObjectTypeCode", "participantObjectTypeCodeRole",
		"participantObjectDataLifeCycle", "participantObjectIDTypeCode",
		"participantObjectSensitivity", "participantObjectID",
		"participantObjectName", "participantObjectQuery",
		"participantObjectDetail", "participantObjectDescription", "mpps", "accession",  "sopClass", 
		"participantObjectContainsStudy", "encrypted", "anonymized", "numberOfInstances", "instance", 
		"distinguisher" })
@Entity
@Name("participantObjectIdentificationDesc")
@Table(name = "am_participant_object_identification_desc", schema = "public")
@SequenceGenerator(name = "am_participant_object_identification_desc_sequence", sequenceName = "am_participant_object_identification_desc_id_seq", allocationSize = 1)
public class ParticipantObjectIdentificationDesc implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@XmlTransient
	@Id
	@GeneratedValue(generator = "am_participant_object_identification_desc_sequence", strategy = GenerationType.SEQUENCE)
	@NotNull
	@Column(name = "id")
	private Integer id;

	@XmlElement(name = "ParticipantObjectTypeCode", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectTypeCode_id")
	protected ElementDescription participantObjectTypeCode;

	@XmlElement(name = "ParticipantObjectTypeCodeRole", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectTypeCodeRole_id")
	protected ElementDescription participantObjectTypeCodeRole;

	@XmlElement(name = "ParticipantObjectDataLifeCycle", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectDataLifeCycle_id")
	protected ElementDescription participantObjectDataLifeCycle;

	@XmlElement(name = "ParticipantObjectIDTypeCode", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectIDTypeCode_id")
	protected ElementDescription participantObjectIDTypeCode;

	@XmlElement(name = "ParticipantObjectSensitivity", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectSensitivity_id")
	protected ElementDescription participantObjectSensitivity;

	@XmlElement(name = "ParticipantObjectID", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectID_id")
	protected ElementDescription participantObjectID;

	@XmlElement(name = "ParticipantObjectName", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectName_id")
	protected ElementDescription participantObjectName;

	@XmlElement(name = "ParticipantObjectQuery", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectQuery_id")
	protected ElementDescription participantObjectQuery;

	@XmlElement(name = "ParticipantObjectDetail", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectDetail_id")
	protected ElementDescription participantObjectDetail;
	
	@XmlElement(name = "ParticipantObjectDescription", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectDescription_id")
	protected ElementDescription participantObjectDescription;
	
	@XmlElement(name = "mpps", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "mpps_id")
	protected ElementDescription mpps;
	
	@XmlElement(name = "accession", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "accession_id")
	protected ElementDescription accession;
	
	@XmlElement(name = "sopClass", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "sopClass_id")
	protected ElementDescription sopClass;
	
	@XmlElement(name = "ParticipantObjectContainsStudy", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "participantObjectContainsStudy_id")
	protected ElementDescription participantObjectContainsStudy;
	
	@XmlElement(name = "encrypted", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "encrypted_id")
	protected ElementDescription encrypted;
	
	@XmlElement(name = "anonymized", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "anonymized_id")
	protected ElementDescription anonymized;
	
	@XmlElement(name = "NumberOfInstances", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "NumberOfInstances_id")
	protected ElementDescription numberOfInstances;
	
	@XmlElement(name = "Instance", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "Instance_id")
	protected ElementDescription instance;

	@XmlAttribute(name = "distinguisher", required = true)
	protected String distinguisher;

	@XmlAttribute(name = "min")
	protected String min;

	@XmlAttribute(name = "max")
	protected String max;

	@XmlAttribute(name = "name")
	protected String name;

	public ElementDescription getNumberOfInstances() {
		return numberOfInstances;
	}

	public void setNumberOfInstances(ElementDescription numberOfInstances) {
		this.numberOfInstances = numberOfInstances;
	}

	public ElementDescription getInstance() {
		return instance;
	}

	public void setInstance(ElementDescription instance) {
		this.instance = instance;
	}

	public ElementDescription getParticipantObjectDescription() {
		return participantObjectDescription;
	}

	public void setParticipantObjectDescription(ElementDescription participantObjectDescription) {
		this.participantObjectDescription = participantObjectDescription;
	}

	public ElementDescription getMpps() {
		return mpps;
	}

	public void setMpps(ElementDescription mpps) {
		this.mpps = mpps;
	}

	public ElementDescription getAccession() {
		return accession;
	}

	public void setAccession(ElementDescription accession) {
		this.accession = accession;
	}

	public ElementDescription getSopClass() {
		return sopClass;
	}

	public void setSopClass(ElementDescription sopClass) {
		this.sopClass = sopClass;
	}

	public ElementDescription getParticipantObjectContainsStudy() {
		return participantObjectContainsStudy;
	}

	public void setParticipantObjectContainsStudy(ElementDescription participantObjectContainsStudy) {
		this.participantObjectContainsStudy = participantObjectContainsStudy;
	}

	public ElementDescription getEncrypted() {
		return encrypted;
	}

	public void setEncrypted(ElementDescription encrypted) {
		this.encrypted = encrypted;
	}

	public ElementDescription getAnonymized() {
		return anonymized;
	}

	public void setAnonymized(ElementDescription anonymized) {
		this.anonymized = anonymized;
	}

	public String getDistinguisher() {
		return distinguisher;
	}

	public void setDistinguisher(String distinguisher) {
		this.distinguisher = distinguisher;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * Gets the value of the participantObjectTypeCode property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectTypeCode() {
		return participantObjectTypeCode;
	}

	/**
	 * Sets the value of the participantObjectTypeCode property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectTypeCode(ElementDescription value) {
		this.participantObjectTypeCode = value;
	}

	/**
	 * Gets the value of the participantObjectTypeCodeRole property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectTypeCodeRole() {
		return participantObjectTypeCodeRole;
	}

	/**
	 * Sets the value of the participantObjectTypeCodeRole property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectTypeCodeRole(ElementDescription value) {
		this.participantObjectTypeCodeRole = value;
	}

	/**
	 * Gets the value of the participantObjectDataLifeCycle property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectDataLifeCycle() {
		return participantObjectDataLifeCycle;
	}

	/**
	 * Sets the value of the participantObjectDataLifeCycle property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectDataLifeCycle(ElementDescription value) {
		this.participantObjectDataLifeCycle = value;
	}

	/**
	 * Gets the value of the participantObjectIDTypeCode property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectIDTypeCode() {
		return participantObjectIDTypeCode;
	}

	/**
	 * Sets the value of the participantObjectIDTypeCode property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectIDTypeCode(ElementDescription value) {
		this.participantObjectIDTypeCode = value;
	}

	/**
	 * Gets the value of the participantObjectSensitivity property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectSensitivity() {
		return participantObjectSensitivity;
	}

	/**
	 * Sets the value of the participantObjectSensitivity property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectSensitivity(ElementDescription value) {
		this.participantObjectSensitivity = value;
	}

	/**
	 * Gets the value of the participantObjectID property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectID() {
		return participantObjectID;
	}

	/**
	 * Sets the value of the participantObjectID property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectID(ElementDescription value) {
		this.participantObjectID = value;
	}

	/**
	 * Gets the value of the participantObjectName property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectName() {
		return participantObjectName;
	}

	/**
	 * Sets the value of the participantObjectName property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectName(ElementDescription value) {
		this.participantObjectName = value;
	}

	/**
	 * Gets the value of the participantObjectQuery property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectQuery() {
		return participantObjectQuery;
	}

	/**
	 * Sets the value of the participantObjectQuery property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectQuery(ElementDescription value) {
		this.participantObjectQuery = value;
	}

	/**
	 * Gets the value of the participantObjectDetail property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getParticipantObjectDetail() {
		return participantObjectDetail;
	}

	/**
	 * Sets the value of the participantObjectDetail property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setParticipantObjectDetail(ElementDescription value) {
		this.participantObjectDetail = value;
	}

	/**
	 * Gets the value of the name property.
	 * 
	 * @return possible object is {@link String }
	 * 
	 */
	public String getName() {
		return name;
	}

	/**
	 * Sets the value of the name property.
	 * 
	 * @param value
	 *            allowed object is {@link String }
	 * 
	 */
	public void setName(String value) {
		this.name = value;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((accession == null) ? 0 : accession.hashCode());
		result = prime * result + ((anonymized == null) ? 0 : anonymized.hashCode());
		result = prime * result + ((distinguisher == null) ? 0 : distinguisher.hashCode());
		result = prime * result + ((encrypted == null) ? 0 : encrypted.hashCode());
		result = prime * result + ((mpps == null) ? 0 : mpps.hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result
				+ ((participantObjectContainsStudy == null) ? 0 : participantObjectContainsStudy.hashCode());
		result = prime * result
				+ ((participantObjectDataLifeCycle == null) ? 0 : participantObjectDataLifeCycle.hashCode());
		result = prime * result
				+ ((participantObjectDescription == null) ? 0 : participantObjectDescription.hashCode());
		result = prime * result + ((participantObjectDetail == null) ? 0 : participantObjectDetail.hashCode());
		result = prime * result + ((participantObjectID == null) ? 0 : participantObjectID.hashCode());
		result = prime * result + ((participantObjectIDTypeCode == null) ? 0 : participantObjectIDTypeCode.hashCode());
		result = prime * result + ((participantObjectName == null) ? 0 : participantObjectName.hashCode());
		result = prime * result + ((participantObjectQuery == null) ? 0 : participantObjectQuery.hashCode());
		result = prime * result
				+ ((participantObjectSensitivity == null) ? 0 : participantObjectSensitivity.hashCode());
		result = prime * result + ((participantObjectTypeCode == null) ? 0 : participantObjectTypeCode.hashCode());
		result = prime * result
				+ ((participantObjectTypeCodeRole == null) ? 0 : participantObjectTypeCodeRole.hashCode());
		result = prime * result + ((sopClass == null) ? 0 : sopClass.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ParticipantObjectIdentificationDesc other = (ParticipantObjectIdentificationDesc) obj;
		if (accession == null) {
			if (other.accession != null)
				return false;
		} else if (!accession.equals(other.accession))
			return false;
		if (anonymized == null) {
			if (other.anonymized != null)
				return false;
		} else if (!anonymized.equals(other.anonymized))
			return false;
		if (distinguisher == null) {
			if (other.distinguisher != null)
				return false;
		} else if (!distinguisher.equals(other.distinguisher))
			return false;
		if (encrypted == null) {
			if (other.encrypted != null)
				return false;
		} else if (!encrypted.equals(other.encrypted))
			return false;
		if (mpps == null) {
			if (other.mpps != null)
				return false;
		} else if (!mpps.equals(other.mpps))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (participantObjectContainsStudy == null) {
			if (other.participantObjectContainsStudy != null)
				return false;
		} else if (!participantObjectContainsStudy.equals(other.participantObjectContainsStudy))
			return false;
		if (participantObjectDataLifeCycle == null) {
			if (other.participantObjectDataLifeCycle != null)
				return false;
		} else if (!participantObjectDataLifeCycle.equals(other.participantObjectDataLifeCycle))
			return false;
		if (participantObjectDescription == null) {
			if (other.participantObjectDescription != null)
				return false;
		} else if (!participantObjectDescription.equals(other.participantObjectDescription))
			return false;
		if (participantObjectDetail == null) {
			if (other.participantObjectDetail != null)
				return false;
		} else if (!participantObjectDetail.equals(other.participantObjectDetail))
			return false;
		if (participantObjectID == null) {
			if (other.participantObjectID != null)
				return false;
		} else if (!participantObjectID.equals(other.participantObjectID))
			return false;
		if (participantObjectIDTypeCode == null) {
			if (other.participantObjectIDTypeCode != null)
				return false;
		} else if (!participantObjectIDTypeCode.equals(other.participantObjectIDTypeCode))
			return false;
		if (participantObjectName == null) {
			if (other.participantObjectName != null)
				return false;
		} else if (!participantObjectName.equals(other.participantObjectName))
			return false;
		if (participantObjectQuery == null) {
			if (other.participantObjectQuery != null)
				return false;
		} else if (!participantObjectQuery.equals(other.participantObjectQuery))
			return false;
		if (participantObjectSensitivity == null) {
			if (other.participantObjectSensitivity != null)
				return false;
		} else if (!participantObjectSensitivity.equals(other.participantObjectSensitivity))
			return false;
		if (participantObjectTypeCode == null) {
			if (other.participantObjectTypeCode != null)
				return false;
		} else if (!participantObjectTypeCode.equals(other.participantObjectTypeCode))
			return false;
		if (participantObjectTypeCodeRole == null) {
			if (other.participantObjectTypeCodeRole != null)
				return false;
		} else if (!participantObjectTypeCodeRole.equals(other.participantObjectTypeCodeRole))
			return false;
		if (sopClass == null) {
			if (other.sopClass != null)
				return false;
		} else if (!sopClass.equals(other.sopClass))
			return false;
		return true;
	}

	public String getMin() {
		if (min == null) {
			min = "0";
		}
		return min;
	}

	public void setMin(String min) {
		if (min == null) {
			min = "0";
		}
		this.min = min;
	}

	public String getMax() {
		if (max == null) {
			max = "*";
		}
		return max;
	}

	public void setMax(String max) {
		if (max == null) {
			max = "*";
		}
		this.max = max;
	}

}
